function [vf,ss] = compute_smooth(mesh,fvf,cd,m)

ND = fvf.ND;
A = zeros(ND*ND,ND);
for i = 1:ND
    
    A((i-1)*ND+1:i*ND,:) = cd{i};
        
end

if nargin < 4
    m = 1;
end

% solve
[~,ss,vv] = svd(A);
ta = cell(m,1);
vf = cell(m,1);
for i = 1:m
    ta{i} = vv(:,end+1-i);
    vf{i} = reshape(fvf.vf*ta{i},mesh.nf,3);
end

if m == 1
    vf = vf{1};
end